Keyboard:
	cli
	pushad
	pushf
	xor eax,eax
loop1:
	in al,64h
	and al,01h
	jz loop1
	in al,60h

	mov ebx,eax

	cmp al,0E0h		; if special key
	je @kb_e		; set previous scancode
	cmp al,0E1h		; to it
	je @kb_e		;

	or al,al		;
	je @kb_f		;
	cmp al,0FFh		;
	je @kb_f		;
	
	cmp al,02Ah		; check for shift
	je @kb_ls		;
	cmp al,036h		;
	je @kb_rs		;

	cmp al,0AAh		; check for shift
	je @kb_lS		; release
	cmp al,0B6h		;
	je @kb_rS		;

	jmp @kb_1

@kb_f:xor al,al
@kb_e:
	mov byte[prev_scode],al
	jmp @kb_0
@kb_s:mov byte[shift],1
	jmp @kb_0
@kb_S:mov byte[shift],0
	jmp @kb_0

@kb_ls:mov byte[lshift],1
	jmp @kb_0
@kb_rs:mov byte[rshift],1
	jmp @kb_0

@kb_lS:mov byte[lshift],0
	jmp @kb_0
@kb_rS:mov byte[rshift],0
	jmp @kb_0

@kb_1:cmp al,02h		; check if keys b/w
	jge $+7		; 02h and 0Dh
	jmp @kb_0		; which are the row of keys above
	cmp al,0Eh		; the alphabets upto backspace
	jle @kb		;

	cmp al,10h		; check if keys b/w
	jge $+7		; 10h and 1Bh
	jmp @kb_0		; which are q w e r t y u i o p [ ]
	cmp al,1Ch		; 
	jle @kb		;

	cmp al,1Eh		; check if keys b/w
	jge $+7		; 1Eh and 28h
	jmp @kb_0		; which are :
	cmp al,28h		; a s d f g h j k l ; '
	jle @kb		;

	cmp al,2Bh		; check if keys b/w
	jge $+7		; 2Ch and 34h
	jmp @kb_0		; which are :
	cmp al,35h		; \ z x c v b n m , . /
	jle @kb		;

	cmp al,39h
	je @kb

	cmp byte[prev_scode],0
	jne @kb_E

	jmp @kb_0
	
@kb:	call getKeyChar

	mov edx,keyBuffer
	add edx,[keyPos]
	mov byte[edx],al
	inc dword[keyBufSize]
	inc dword[keyPos]

@kb1:	;call putKeyChar
	jmp @kb_0

@kb_E:mov byte[prev_scode],0
	mov edx,Keymap_E0
	mov al,byte[edx+eax]
	call useSpecKeys
	
@kb_0:call MoveCursor
	mov al,20h
	out 20h,al	; Send EOI (End of Interrupt)

	popf
	popad
	iret

getKeyChar:
	pushf
	push edx

	cmp byte[lshift],1
	je @gk_shift
	cmp byte[rshift],1
	je @gk_shift
	mov edx,Keymap_NoCaps
	jmp @gk_exit
@gk_shift:
	mov edx,Keymap_Caps
@gk_exit:
	mov al,[edx+eax]
	mov byte[ds:0B8080h],al
	mov byte[ds:0B8081h],al
	pop edx
	popf
	ret

putKeyChar:
	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	cmp al,0Dh		; enter
	je @pkc_cr
	cmp al,08h		; backspace
	je @pkc_bk
	mov ah,0Eh
	mov word [edi],ax
	inc dword [TextPtr]
	jmp @pkc_exit
@pkc_cr:
	call PutCR
	jmp @pkc_exit
@pkc_bk:
	call PutBkSpce
@pkc_exit:
	ret

useSpecKeys:
	cmp al,0Dh
	je short $+7
	jmp @use_exit
	call PutCR
@use_exit:
	ret

getch:
	xor eax,eax
	xor ecx,ecx
	xor edx,edx
@g1:	cmp dword[keyBufSize],0
	je @g1
	mov edx,keyBuffer
	add edx,[keyPos]
	dec edx
	mov al,byte[edx]
	dec dword[keyBufSize]
	dec dword[keyPos]

	mov edx,keyBuffer
	inc edx
	mov esi,edx
	mov edi,keyBuffer
	mov ecx,99
	rep movsb

@g3:	call putKeyChar
	ret

